﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;
namespace ModbusDemo.Common
{
    public class ModualAlarm
    {
        public const ushort usChannelNumber = 8;
        private const string sAlarmTopic = "Witium/WTDS78X/20193261/Alarm";
        public Hashtable hMqtttAlarmMap = new Hashtable();
        public bool bErrorHasSend = false;
        private string sAlarmJson;
        private string sAlarmJsonPackage;
        //private IMqttClient mqttClient = null;
        public enum eAlarmCode : ushort
        {
            ChannelNoError = 0,
            ChannelCommunError = 1,
            ChannelCollectDataError = 2,
            ChannelDataRespError = 4,
            ChannelDataChangeError = 8
        }
        public void vSetAlarmList(ushort usAddress, ushort[] usChannel, ushort[] usChannelAlarmcode,bool bStringIncrease)
        {
            ushort i = 0;
            hMqtttAlarmMap.Add("addr", usAddress.ToString());
            string sAlarm = "alm";
            foreach (ushort usdata in usChannelAlarmcode)
            {
                hMqtttAlarmMap.Add(sAlarm + i, usChannelAlarmcode[i]);
                i++;
            }
            hMqtttAlarmMap.Add("ts", Form1.GetTimeStamp());
            sAlarmJson += JsonConvert.SerializeObject(hMqtttAlarmMap);
            if (bStringIncrease == true)
            {
                sAlarmJson += ",";
            }
        }
        public async Task vPublishAlarmPackageJson(IMqttClient mqttClient)
        {
            sAlarmJson = "[" + sAlarmJson  + "]";
            var message = new MqttApplicationMessageBuilder()
                                .WithTopic(sAlarmTopic)
                                .WithPayload(sAlarmJson)
                                .WithAtMostOnceQoS()
                                .WithRetainFlag(false)
                                .Build();
            await mqttClient.PublishAsync(message);
        }
    }
}
