﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Text.RegularExpressions;
using System.Collections;
using System.Management;
using System.Net.NetworkInformation;

namespace ModbusDemo.Common
{
    class ModSearch
    {
        public struct DeviceInfo
        {
            public string ModuleName;
            public string MacAddr;
            public string IpAddr;
            public string Netmask;
            public string Gateway;
            public bool bActive;
        };

        public UdpClient client;
        public IPEndPoint endpoint;
        Thread searchth;
        ManualResetEvent mre = new ManualResetEvent(false);

        public DeviceInfo m_DeviceInfo;
        public ArrayList myHMIList = new ArrayList();

        string FMAC =null;

        string localip = null;

        /// <summary>
        /// 构造函数
        /// </summary>
        public ModSearch()
        {
            myHMIList.Clear();
  
            NetworkInterface[] nics = NetworkInterface.GetAllNetworkInterfaces();
            foreach (NetworkInterface adapter in nics)
            {
                if (adapter.Name == "本地连接")  //这里是为了匹配我自己电脑网卡
                {
                    bool Pd1 = (adapter.NetworkInterfaceType == NetworkInterfaceType.Ethernet); //判断是否是以太网连接
                    if (Pd1)
                    {
                        {
                            IPInterfaceProperties ip = adapter.GetIPProperties();     //IP配置信息
                            UnicastIPAddressInformationCollection ipCollection = ip.UnicastAddresses;
                            foreach (UnicastIPAddressInformation ipadd in ipCollection)
                            {
                                if (ipadd.Address.AddressFamily == AddressFamily.InterNetwork)
                                     this.localip = ipadd.Address.ToString();//获取ip
                            }
                        }
                    }
                }
             }          
        }

        public void ThStart()
        {
            if (mre != null)
                mre.Reset();
            Console.WriteLine("搜索线程开始....");
            searchth = new Thread(ThreadMethod);
            searchth.IsBackground = true;
            searchth.Start();         
        }

        public void ThStop()
        {
            Console.WriteLine("搜索线程结束....");
            mre.Set();
        }

        public int HMICount()
        {
            return myHMIList.Count;
        }

        private void ThreadMethod()
        {
            byte[] sendBytes = new byte[] { 0x57, 0x54, 0x04, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x55, 0xAA };
            int iReadBytes = 0;

            try
            {
               client = new UdpClient(new IPEndPoint(IPAddress.Any, 0));
               // client = new UdpClient(new IPEndPoint(IPAddress.Parse(this.localip), 0));

                endpoint = new IPEndPoint(IPAddress.Parse("255.255.255.255"), 5048);
                client.Send(sendBytes, sendBytes.Length, endpoint);
                Thread.Sleep(500);

                byte[] recvBytes;
                client.Client.Blocking = false;
                while (!mre.WaitOne(500))
                {
                    iReadBytes = 30;
                    int buffSizeCurrent;
                    buffSizeCurrent = client.Client.Available;
                    if (buffSizeCurrent > 0)
                    {
                        recvBytes = client.Receive(ref endpoint);
                        iReadBytes = recvBytes.Length;
                        DoRecvDataCallBack(recvBytes, iReadBytes);
                    }
                }
            }catch
            {
               
            }
           
        }

        public Boolean DoRecvDataCallBack(byte[] pcData, int iRecvLength)
        {
            int i;
            int count = 0;
            byte[] pBuf = pcData;
            int iDataLength = 0;
         
            if (iRecvLength < 8)
                return false;

            if ((pBuf[0] == (byte)0x57) && (pBuf[1] == (byte)0x54) && (pBuf[iRecvLength - 2] == (byte)0x55) && (pBuf[iRecvLength - 1] == (byte)0xAA))
            {
                iDataLength = (int)(pBuf[2] & 0xFF)
                                | (int)((pBuf[3] & 0xFF) << 8)
                                | (int)((pBuf[4] & 0xFF) << 16)
                                | (int)((pBuf[5] & 0xFF) << 24);

                if ((iDataLength >= 4) && (iRecvLength == 8 + iDataLength))
                {                   
                    System.Text.ASCIIEncoding asciiEncoding = new System.Text.ASCIIEncoding();
                    m_DeviceInfo.bActive = false;
                                      
                    for (i = 0; i < 100; i++ )
                    {
                        if (asciiEncoding.GetString(pBuf, 6 + i, 1) == "\0")
                            break;
                        count++;
                    }
                   // m_DeviceInfo.ModuleName = String.Format("{0}", asciiEncoding.GetString(pBuf, 6, count));
                    //脱机
                    m_DeviceInfo.ModuleName = String.Format("{0}{1}{2}{3}", asciiEncoding.GetString(pBuf, 6, 1),
                                                                                      asciiEncoding.GetString(pBuf, 7, 1),
                                                                                        asciiEncoding.GetString(pBuf, 8, 1),
                                                                                        asciiEncoding.GetString(pBuf, 9, 1));
                    m_DeviceInfo.MacAddr = String.Format("{0}:{1}:{2}:{3}:{4}:{5}", pBuf[10], pBuf[11], pBuf[12], pBuf[13], pBuf[14], pBuf[15]);
                    m_DeviceInfo.IpAddr = String.Format("{0}.{1}.{2}.{3}", pBuf[16], pBuf[17], pBuf[18], pBuf[19]);
                    m_DeviceInfo.Netmask = String.Format("{0}.{1}.{2}.{3}", pBuf[20], pBuf[21], pBuf[22], pBuf[23]);
                    m_DeviceInfo.Gateway = String.Format("{0}.{1}.{2}.{3}", pBuf[24], pBuf[25], pBuf[26], pBuf[27]);                  
                    if (m_DeviceInfo.IpAddr != "0.0.0.0")
                    {
                        myHMIList.Add(m_DeviceInfo);
                    }
                   
                    return true;
                }
            }
            return false;
        }
    }
}
