﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ModbusDemo.Common;
using System.Threading;
using System.Text.RegularExpressions;

namespace ModbusDemo
{
    public partial class MDemo : Form
    {

        WTModbus ReadTest;
        const ushort address = 17;
        const ushort num = 6;
        const ushort DevicePort = 502;
        string DeviceIP;

        ManualResetEvent showmre = new ManualResetEvent(false);
        public delegate void invokeDelegate();

        public MDemo()
        {
            InitializeComponent();
            ReadTest = new WTModbus();
        }

        Thread t_ReadCoil;
        private void TestBtn_Click(object sender, EventArgs e)
        {
            this.TestBtn.Enabled = false;        
            if (this.IPsetBox.Text != "")
            {
                DeviceIP = this.IPsetBox.Text;
            }
            else
            {
                MessageBox.Show("请检查IP输入是否正确");
                this.TestBtn.Enabled = true;
                return;
            }
        
            if (showmre != null)
            {
                showmre.Reset();
            }
            t_ReadCoil = new Thread(ReadCoilProc);
            t_ReadCoil.IsBackground = true;
            t_ReadCoil.Start();                 
        }
       
        private void ReadCoilProc(object obj)
        {                    
            short allval;                    
            byte[] temp = new byte[6];
            int ret;

            while (!showmre.WaitOne(500))
            {
                //读线圈
                ret = ReadTest.ReadCoilStatus(address, num, DeviceIP, DevicePort, ref temp);
                allval = BitConverter.ToInt16(temp, 0);

                invokeDelegate update = () =>
                {
                    foreach (Control control in this.CoilBox.Controls)
                    {
                        if(control is PictureBox)
                        {
                            if ((allval >> Convert.ToUInt16((control as PictureBox).Tag) & 0x1) == 1)
                            {
                                (control as PictureBox).BackColor = Color.Green;
                            }
                            else
                            {
                                (control as PictureBox).BackColor = Color.Black;
                            }
                        }                      
                    }
                };
                Invoke(update);
            }
                               
        }

        private void stopbtn_Click(object sender, EventArgs e)
        {
            this.TestBtn.Enabled = true;
            if (showmre != null)
                showmre.Set();

            foreach (Control control in this.CoilBox.Controls)
            {
                if (control is PictureBox)
                {
                    (control as PictureBox).BackColor = Color.Black;                    
                }
            }
        }
    }
}
