﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ModbusDemo.Common;
using System.Threading;
using System.Text.RegularExpressions;

namespace ModbusDemo
{
    public partial class ProTest : Form
    {
        WTModbus ReadTest;
      //  WTModbus TenReadTest; // = new WTModbus[10];
        const ushort address = 1;
        const ushort num = 16;
        const ushort DevicePort = 502;
        string DeviceIP = "192.168.1.57";
        ManualResetEvent showmre = new ManualResetEvent(false);
        public delegate void invokeDelegate();

        //Ten module
        string [] TenDeviceIP = new string[10];


        public ProTest()
        {
            InitializeComponent();
            setTenIP();
        }


        private void setTenIP()
        {
            TenDeviceIP[0] = "192.168.102";
            TenDeviceIP[1] = "192.168.113";
            TenDeviceIP[2] = "192.168.112";
            TenDeviceIP[3] = "192.168.109";
            TenDeviceIP[4] = "192.168.110";
            TenDeviceIP[5] = "192.168.103";
            TenDeviceIP[6] = "192.168.111";
            TenDeviceIP[7] = "192.168.107";
            TenDeviceIP[8] = "192.168.104";
            TenDeviceIP[9] = "192.168.106";
        }


        Boolean hwstartuse = false;
        Thread t_ReadCoil;
        bool closethread = false;
        private void hwstart_Click(object sender, EventArgs e)
        {            
            if(!hwstartuse)
            {
                hwstartuse = !hwstartuse;
                this.hwstart.Text = "停止";
                t_ReadCoil = new Thread(ReadCoilProc);
                t_ReadCoil.IsBackground = true;
                t_ReadCoil.Start();
                closethread = false;
            }else
            {
                hwstartuse = !hwstartuse;
                this.hwstart.Text = "开始";
                closethread = true;
            }
        }

        private void ReadCoilProc(object obj)
        {
            short allval;
            int readcount = 0;
            int failcount = 0;
            byte[] temp = new byte[2];
            int ret;
            ReadTest = new WTModbus();
            int starttime = System.Environment.TickCount;

            while (true)
            {
                //读线圈
                ret = ReadTest.ReadCoilStatus(address, num, DeviceIP, DevicePort, ref temp);
               // allval = BitConverter.ToInt16(temp, 0);

                if(ret == 0)
                {
                    readcount++;
                }else
                {
                    failcount++;
                }
                
                invokeDelegate update = () =>
                {
                    this.label2.Text = readcount.ToString() + "次";
                    this.label9.Text = failcount.ToString() + "次";
                    this.label4.Text = (System.Environment.TickCount - starttime).ToString() + "ms";
                };
                Invoke(update);

                if (closethread)
                {
                    break;
                }
            }
        }

        bool []tenclosethread = new bool[10];
        WTModbus[]TReadTest = new WTModbus[10];
        private void eReadCoilProc(object obj)
        {

            //WTModbus TReadTest;
            int readcount = 0;
            int failcount = 0;
            byte[] temp = new byte[2];
            int ret;
            int thnum = 0;
            
            thnum = int.Parse(obj.ToString());
            this.TReadTest[thnum] = new WTModbus();
            int starttime = System.Environment.TickCount;

            while (true)
            {
                //读线圈
                ret = TReadTest[thnum].ReadCoilStatus(address, num, TenDeviceIP[thnum], DevicePort, ref temp);
                
                if (ret == 0)
                {
                    readcount++;
                }
                else
                {
                    failcount++;
                }

                invokeDelegate update = () =>
                {
                    foreach(Control c in groupBox3.Controls)
                    {
                        if(c is Label)
                        {
                            if(c.Name == ("label1" + thnum.ToString()) )
                                c.Text = readcount.ToString() + "次";
                            if(c.Name == ("label2" + thnum.ToString()))
                                c.Text = (System.Environment.TickCount - starttime).ToString() + "ms";
                        }
                    }
                };
                Invoke(update);

                if (tenclosethread[thnum])
                {
                    break;
                }
            }
        }


        private void sfstart_Click(object sender, EventArgs e)
        {

        }

        Thread []ten_ReadCoil = new Thread[10];
        private void tenthrun_Click(object sender, EventArgs e)
        {
            int i = 0;

            if (!hwstartuse)
            {
                hwstartuse = !hwstartuse;
                this.tenthrun.Text = "停止";
                for (i = 0; i < 10; i++ )
                {
                    tenclosethread[i] = false;
                    ten_ReadCoil[i] = new Thread(new ParameterizedThreadStart(eReadCoilProc));
                    ten_ReadCoil[i].IsBackground = true;
                    ten_ReadCoil[i].Start(i.ToString());

                }
                
                
            }
            else
            {
                hwstartuse = !hwstartuse;
                for (i = 0; i < 10; i++)
                {
                    tenclosethread[i] = true;
                }
                this.tenthrun.Text = "10线程测试";
                 
            }
        }

        private void onethrun_Click(object sender, EventArgs e)
        {
            if (!hwstartuse)
            {
                hwstartuse = !hwstartuse;
                this.onethrun.Text = "停止";
                t_ReadCoil = new Thread(oneReadCoilProc);
                t_ReadCoil.IsBackground = true;
                t_ReadCoil.Start();
                closethread = false;
            }
            else
            {
                hwstartuse = !hwstartuse;
                this.onethrun.Text = "单一线程测试";
                closethread = true;
            }
        }

        WTModbus[] TenReadTest = new WTModbus[10];
        private void oneReadCoilProc(object obj)
        {

            int []readcount = new int[10];
            int []failcount =  new int[10];
            byte[]temp = new byte[2];
            int []ret = new int[10];
          
            int i = 0;
            int []tenstatrttime = new int[10];

            for (i = 0; i < 10; i++)
            {
                TenReadTest[i] = new WTModbus();

            }

            for (i = 0; i < 10; i++)
            {
                tenstatrttime[i] = System.Environment.TickCount;

            }

            while (true)
            {
                //读线圈
                for (i = 0; i < 10; i++ )
                {
                    ret[i] = TenReadTest[i].ReadCoilStatus(address, num, TenDeviceIP[i], DevicePort, ref temp);
                    if (ret[i] == 0)
                    {
                        readcount[i]++;
                    }
                    else
                    {
                        failcount[i]++;
                    }

                    invokeDelegate update = () =>
                    {
                        foreach (Control c in groupBox3.Controls)
                        {
                            if (c is Label)
                            {
                                if (c.Name == ("label1" + i.ToString()))
                                    c.Text = readcount[i].ToString() + "次";
                                if (c.Name == ("label2" + i.ToString()))
                                    c.Text = (System.Environment.TickCount - tenstatrttime[i]).ToString() + "ms";
                            }
                        }
                    };
                    Invoke(update);
                }
                              
                if (closethread)
                {
                    break;
                }
            }
        }




    }
}
