﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ModbusDemo
{
    class _414P
    {

        //铂电阻+2路开关
        const int MAX_AN_CH_NUM = 4;
        ushort[] typeData = new ushort[MAX_AN_CH_NUM];//当前量程读数
        byte[] AbnoSignal = new byte[MAX_AN_CH_NUM];//通道异常信号
        ushort[] Inputtype = new ushort[MAX_AN_CH_NUM];//输入类型
        ushort[] m_u16ADData = new ushort[MAX_AN_CH_NUM];  //保存AD的值
        string[] WireN=new string[] { "2-Wire","3-Wire" ,"4-Wire"};
        string[] Strcom = new string[] {"PT100(385) -50~150℃","PT100(385) 0~100℃",
                                        "PT100(385) 0~200℃","PT100(385) 0~400℃",
                                        "PT100(385) -200~200℃","PT100(391) -50~150℃",
                                        "PT100(391) 0~100℃","PT100(391) 0~200℃",
                                        "PT100(391) 0~400℃","PT100(391) -200~200℃",
                                        "PT1000 -40~160℃","BALCO 500 -30~120℃",
                                        "Ni(50) -80~100℃","Ni(508) 0~100℃"};
        public class UserInfo
        {
            public int UserId { get; set; }
            public string UserCompany { get; set; }

            public float Data { get; set; }

            public ushort UserModel { get; set; }
            public double[] NegMin = {-50, 0, 0, 0, -200.00, -50.00,
                                      0, 0, 0, -200.00, -40, -30, -80, 0 }; //负数最小值

            public double[] NegMax = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};//负数最大值

            public double[] PosMin = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
            //正数最小值
            public double[] PosMax = { 150, 100, 200, 400, 200, 150, 100, 200,
                                       400, 200, 160, 120 ,100, 100};
            //正数最大值

            public ushort[] usMin = {0xD556, 0x0000, 0x0000, 0x0000, 0x8000, 0xD556, 0x0000 ,
                                 0x0000, 0x0000, 0x8000, 0xE000, 0xE000, 0x999A, 0x0000};

            public ushort[] usMax = {0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF,0x7FFF, 0x7FFF,
                                 0x7FFF ,0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF};
        }
        UserInfo passageway0 =new UserInfo();
        UserInfo passageway1 = new UserInfo();
        UserInfo passageway2 = new UserInfo();
        UserInfo passageway3 = new UserInfo();
        public string[] RtdValue(ushort[] typeData, ushort[] Inputtype)
        {
            string[] Valuepass = new string[MAX_AN_CH_NUM];
            if (typeData != null || Inputtype != null)
            {
                passageway0.UserId = 0;//通道
                passageway0.Data = typeData[0];//数据
                passageway0.UserCompany = Strcom[Inputtype[0]];//通道类型
                passageway0.UserModel = Inputtype[0];//确定计算公式

                passageway1.UserId = 1;//通道
                passageway1.Data = typeData[1];//数据
                passageway1.UserCompany = Strcom[Inputtype[1]];//通道类型
                passageway1.UserModel = Inputtype[1];//确定计算公式

                passageway2.UserId = 2;//通道
                passageway2.Data = typeData[2];//数据
                passageway2.UserCompany = Strcom[Inputtype[2]];//通道类型
                passageway2.UserModel = Inputtype[2];//确定计算公式

                passageway3.UserId = 3;//通道
                passageway3.Data = typeData[3];//数据
                passageway3.UserCompany = Strcom[Inputtype[3]];//通道类型
                passageway3.UserModel = Inputtype[3];//确定计算公式

                //////输入格式为：NegMin   NegMax  PosMin  PosMax usMin usMax
                Valuepass[0] = current(passageway0.NegMin[passageway0.UserModel], passageway0.NegMax[passageway0.UserModel], passageway0.PosMin[passageway0.UserModel],
                    passageway0.PosMax[passageway0.UserModel], passageway0.usMin[passageway0.UserModel], passageway0.usMax[passageway0.UserModel],
                    passageway0.Data); //处理函数

                Valuepass[1] = current(passageway1.NegMin[passageway1.UserModel], passageway1.NegMax[passageway1.UserModel], passageway1.PosMin[passageway1.UserModel],
                                passageway1.PosMax[passageway1.UserModel], passageway1.usMin[passageway1.UserModel], passageway1.usMax[passageway1.UserModel],
                                passageway1.Data); //处理函数

                Valuepass[2] = current(passageway2.NegMin[passageway2.UserModel], passageway2.NegMax[passageway2.UserModel], passageway2.PosMin[passageway2.UserModel],
                    passageway2.PosMax[passageway2.UserModel], passageway2.usMin[passageway2.UserModel], passageway2.usMax[passageway2.UserModel],
                    passageway2.Data); //处理函数

                Valuepass[3] = current(passageway3.NegMin[passageway3.UserModel], passageway3.NegMax[passageway3.UserModel], passageway3.PosMin[passageway3.UserModel],
                    passageway3.PosMax[passageway3.UserModel], passageway3.usMin[passageway3.UserModel], passageway3.usMax[passageway3.UserModel],
                    passageway3.Data); //处理函数
                return Valuepass;
            }
            else
            return Valuepass=null;
        }

        double parameter;
        string parameter2;
        //输入格式为：NegMin   NegMax  PosMin  PosMax usMin usMax
        public string current(double NegMin, double NegMax, double PosMin,
            double PosMax, double usMin, double usMax,
            float Input) //处理函数
        {
            if (Input >= 0x0000
             && Input <= 0x7FFF)
            {
                parameter = Convert.ToSingle(PosMin + ((PosMax - PosMin) * Input) / usMax);
                parameter2 = parameter.ToString("F3");

            }
            else
            {
                parameter = -Convert.ToSingle(PosMin + ((PosMax - PosMin) * (0x10000 - Input)) / (0x10000 - usMax));
                parameter2 = parameter.ToString("F3");
            }

            if (parameter2 == "0.000")
            {
                parameter2 = "0.0";
                return parameter2;
            }
            else
                return parameter2;
        }






    }
}
