﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ModbusDemo.MessageFormat;
using ModbusDemo.Common;
using System.Collections;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;
namespace ModbusDemo.Modular
{
    class ModualPoll
    {
        public  const byte  byX14pNumber                                = 4;
        private const byte  byX14pReadDataStartAddress                  = 0;
        public  const byte  byX14pReadDataNumber                        = 4;
        private const byte  byX14pReadTypeStartAddress                  = 10;
        private const byte  byX14pReadTypeNumber                        = 4;

        public const double dX14pMinCovertData                         = 0;
        public const double dx14pMaxConverData                         = 60;
        public const ushort us14pMaxJumTemper                          = 10;
        public static byte[] byX14pIdlist = { 1,17, 28, 29 };
        public static modual.pcx14P cx14P = new modual.pcx14P(byX14pIdlist);
        public static _414P c14formulasormual = new _414P();

        public  const byte  byX18xNumber                                = 8;
        private const byte  byX18xReadDataStartAddress                  = 0;
        public  const byte  byX18xReadDataNumber                        = 8;
        private const byte  byX18xReadTypeStartAddress                  = 10;
        private const byte  byX18xReadTypeNumber                        = 8;

        public  const double dX18xMinConvertData                        = 0;
        private const ushort dX18xMaxJumpData                           = 2;
        public static byte[] byX18xIdlist                              = {3,6,12,13,21,25,45,53};
        private static modual.eX18xSensorChannelType[,] sX18xChannelType =  new modual.eX18xSensorChannelType[byX18xNumber,byX18xReadDataNumber]{{modual.eX18xSensorChannelType.Weiertai,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Mike_7,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},//东中转池     ID  3
                                                                                                                                        {modual.eX18xSensorChannelType.Mike_7,modual.eX18xSensorChannelType.Weiertai,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},         //西西中转池   ID  6
                                                                                                                                        {modual.eX18xSensorChannelType.Mike_5,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},             //沉砂池       ID  12
                                                                                                                                        {modual.eX18xSensorChannelType.Mike_7,modual.eX18xSensorChannelType.Weiertai,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},
                                                                                                                                        {modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},               //八角池       ID  21
                                                                                                                                        {modual.eX18xSensorChannelType.Mike_6,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},            //匀浆池        ID  25
                                                                                                                                        {modual.eX18xSensorChannelType.Mike_5,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},            //出料池        ID  45
                                                                                                                                        {modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null}};

        public static modual.pcx18X cx18x = new modual.pcx18X(byX18xIdlist, sX18xChannelType);
        private static _418X c18xformulasormual = new _418X();


        public  const byte  byX78cNumber                                = 6;
        private const byte  byX78cInputRegStartAddress                  = 0;
        public  const byte  byX78cInputRegNumber                        = 8;
        private const byte  byX78cOutputRegStartAddress                 = 16;
        public  const byte  byX78cOutputRegNumber                       = 8;
        public  static byte[] byX78cIdlist                              = {11,20,33,34,55,56};
        public  static modual.pcx78C cx78c = new modual.pcx78C(byX78cIdlist);

        
        public  const byte  byX66cNumber                                = 32;
        private const byte  byX66cRelayRegStartAddress                  = 16;
        public  const byte  byX66cRelayRegNumber                        = 6;
        public  static byte[] byX66cIdlist                              = {9,10,14,15,16,19,22,23,24,26,30,31,32,35,36,37,38,39,40,41,42,43,44,46,47,48,49,50,51,52,54,57};
        public  static modual.pcx66C cx66c = new modual.pcx66C(byX66cIdlist);

        public static ModualAlarm cModualAlarm  = new ModualAlarm();

        public static void vAllNodePoll()
        {
            for (byte i = 0; i < byX14pNumber; i++)
            {
                ModbusComm.eModbusErrorCode  ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                string[][] sTempString = new string[byX14pNumber][];
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx14P.sX14pDataStruct[i].usX14pRegData, cx14P.byModbusID[i], byX14pReadDataStartAddress, byX14pReadDataNumber);
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx14P.sX14pDataStruct[i].usX14pRegType, cx14P.byModbusID[i], byX14pReadTypeStartAddress, byX14pReadTypeNumber);
                sTempString[i] = c14formulasormual.RtdValue(cx14P.sX14pDataStruct[i].usX14pRegData, cx14P.sX14pDataStruct[i].usX14pRegType);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (byte j = 0; j < byX14pReadTypeNumber; j++)
                    {
                        cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] = (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
                else
                {
                    for (byte j = 0; j < byX14pReadTypeNumber; j++)
                    {
                        cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }

                for (byte j = 0; j < byX14pReadTypeNumber; j++)
                {
                    cx14P.sX14pDataStruct[i].dNowConvertData[j] = double.Parse(sTempString[i][j]);
                    //if (cx14P.sX14pDataStruct[i].dX14pNowConvertData[j]  <= dX14pMinCovertData  || cx14P.sX14pDataStruct[i].dX14pNowConvertData[j] >= dx14pMaxConverData )
                    //{
                    //    cx14P.sX14PAlarmStruct[i].eNowAlarmCode[j] |= ModualAlarm.eAlarmCode.ChannelCollectDataError;
                    //}
                    if (cx14P.sX14PAlarmStruct[i].bDataNotFirstIncreaseOrDecrease == true)
                    {
                        if (cx14P.sX14pDataStruct[i].dNowConvertData[j] - cx14P.sX14pDataStruct[i].dBeforeConvertData[j] >= us14pMaxJumTemper && cx14P.sX14pDataStruct[i].dBeforeConvertData[j] - cx14P.sX14pDataStruct[i].dNowConvertData[j] >= us14pMaxJumTemper)
                        {
                            cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                        else
                        {
                            cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                    }
                    cx14P.sX14pDataStruct[i].dBeforeConvertData[j] = cx14P.sX14pDataStruct[i].dNowConvertData[j];
                }
                cx14P.sX14PAlarmStruct[i].bDataNotFirstIncreaseOrDecrease = true;
            }

            for (byte i = 0; i < byX18xNumber; i++)
            {
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                string[][] sTempString = new string[byX18xNumber][];
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx18x.sX18xDataStruct[i].usRegData, cx18x.byModbusID[i], byX18xReadDataStartAddress, byX18xReadDataNumber);
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx18x.sX18xDataStruct[i].usTypeData, cx18x.byModbusID[i], byX18xReadTypeStartAddress, byX18xReadTypeNumber);
                sTempString[i] = c18xformulasormual.Value(cx18x.sX18xDataStruct[i].usRegData, cx18x.sX18xDataStruct[i].usTypeData);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (sbyte j = 0; j < byX18xReadTypeNumber; j++)
                    {
                        cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
                else
                {
                    for (sbyte j = 0; j < byX18xReadTypeNumber; j++)
                    {
                        cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] |= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }

                for (byte j = 0; j < byX18xReadTypeNumber; j++)
                {
                    switch (cx18x.beChannelType[i, j])
                    {
                        case modual.eX18xSensorChannelType.Weiertai:
                             cx18x.sX18xDataStruct[i].dNowConvertData[j] = 8- ((double.Parse(sTempString[i][j]) - 4) / 16 * 8);
                             break;
                        case modual.eX18xSensorChannelType.Mike_5:
                             cx18x.sX18xDataStruct[i].dNowConvertData[j] = 5 - ((double.Parse(sTempString[i][j]) - 4) / 16 * 5);
                             break;
                        case modual.eX18xSensorChannelType.Mike_6:
                             cx18x.sX18xDataStruct[i].dNowConvertData[j] = 6 - ((double.Parse(sTempString[i][j]) - 4) / 16 * 6);
                             break;
                        case modual.eX18xSensorChannelType.Mike_7:
                             cx18x.sX18xDataStruct[i].dNowConvertData[j] = 7 - ((double.Parse(sTempString[i][j]) - 4) / 16 * 7);
                             break;
                        case modual.eX18xSensorChannelType.Null:
                             cx18x.sX18xDataStruct[i].dNowConvertData[j] = 0;
                             break;
                        default:
                            break;
                    }
                    if (cx18x.sX18xAlarmstruct[i].bDataNotFirstIncreaseOrDecrease == true)
                    {
                        if (cx18x.sX18xDataStruct[i].dNowConvertData[j] - cx18x.sX18xDataStruct[i].dBeforeConvertData[j] >= dX18xMaxJumpData || cx18x.sX18xDataStruct[i].dBeforeConvertData[j] - cx18x.sX18xDataStruct[i].dNowConvertData[j] >= dX18xMaxJumpData)
                        {
                            cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                        else
                        {
                            cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                    }
                    cx18x.sX18xDataStruct[i].dBeforeConvertData[j] = cx18x.sX18xDataStruct[i].dNowConvertData[j];
                }
                cx18x.sX18xAlarmstruct[i].bDataNotFirstIncreaseOrDecrease = true;
            }
            for (byte i = 0; i < byX78cNumber; i++)
            {
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out cx78c.sX78cRegStatusStruct[i].bInputRegStatus,  cx78c.byModbusID[i], byX78cInputRegStartAddress,  byX78cInputRegNumber);
                ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out cx78c.sX78cRegStatusStruct[i].bOutPutRegStatus, cx78c.byModbusID[i], byX78cOutputRegStartAddress, byX78cOutputRegNumber);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (sbyte j = 0; j < byX78cInputRegNumber + byX78cOutputRegNumber; j++)
                    {
                        cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
                else
                {
                    for (sbyte j = 0; j < byX78cInputRegNumber + byX78cOutputRegNumber; j++)
                    {
                        cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
            }

            for (byte i = 0; i < byX66cNumber; i++)
            {
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                ModbusErrorCode =  ModbusComm.Modbus_ReadCoilsTask(out cx66c.sX66cRegStatusStruct[i].bRegRelayStatus, cx66c.byModbusID[i], byX66cRelayRegStartAddress, byX66cRelayRegNumber);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (sbyte j = 0; j < byX66cRelayRegNumber; j++)
                    {
                        cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
                else
                {
                    for (sbyte j = 0; j < byX66cRelayRegNumber; j++)
                    {
                        cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
            }
        }
        public static string stAll_Poll_Package()
        {
            string stPollString;
            stPollString = "[";
            for (sbyte i = 0; i < byX14pNumber; i++)
            {
                string stIdString = cx14P.byModbusID[i].ToString();
                WTDR14P OneNodeJsonPackage = new WTDR14P(stIdString, cx14P.sX14pDataStruct[i].dNowConvertData[0], cx14P.sX14pDataStruct[i].dNowConvertData[1], cx14P.sX14pDataStruct[i].dNowConvertData[2], cx14P.sX14pDataStruct[i].dNowConvertData[3], Form1.GetTimeStamp());
                stPollString += JsonConvert.SerializeObject(OneNodeJsonPackage) + ",";
            }
            for (sbyte i = 0; i < byX18xNumber; i++)
            {
                string stIdString = cx18x.byModbusID[i].ToString();
                WTDR18X OneNodeJsonPackage = new WTDR18X(stIdString, cx18x.sX18xDataStruct[i].dNowConvertData[0], cx18x.sX18xDataStruct[i].dNowConvertData[1], cx18x.sX18xDataStruct[i].dNowConvertData[2], cx18x.sX18xDataStruct[i].dNowConvertData[3], cx18x.sX18xDataStruct[i].dNowConvertData[4], cx18x.sX18xDataStruct[i].dNowConvertData[5], cx18x.sX18xDataStruct[i].dNowConvertData[6], cx18x.sX18xDataStruct[i].dNowConvertData[7], Form1.GetTimeStamp());
                stPollString += JsonConvert.SerializeObject(OneNodeJsonPackage) + ",";
            }
            for (sbyte i = 0; i < byX78cNumber; i++)
            {
                string stIdString = cx78c.byModbusID[i].ToString();
                _478C cBoolConvertInt = new _478C();
                int[] InputConvert,OutPutConver;
                InputConvert = cBoolConvertInt.IO(cx78c.sX78cRegStatusStruct[i].bInputRegStatus);
                OutPutConver = cBoolConvertInt.IO(cx78c.sX78cRegStatusStruct[i].bOutPutRegStatus);
                WTDR78C OneNodeJsonPackage = new WTDR78C(stIdString, InputConvert[0], InputConvert[1],InputConvert[2], InputConvert[3], InputConvert[4], InputConvert[5],InputConvert[6], InputConvert[7], OutPutConver[0], OutPutConver[1], OutPutConver[2], OutPutConver[3], OutPutConver[4], OutPutConver[5], OutPutConver[6], OutPutConver[7],Form1.GetTimeStamp());
                stPollString += JsonConvert.SerializeObject(OneNodeJsonPackage) + ",";
            }
            for (sbyte i = 0; i < byX66cNumber; i++)
            {
                string stIdString = cx66c.byModbusID[i].ToString();
                _478C cBoolConvertInt = new _478C();
                int[] sRelayConvert;
                sRelayConvert = cBoolConvertInt.IO(cx66c.sX66cRegStatusStruct[i].bRegRelayStatus);
                WTDR66C OneNodeJsonPackage = new WTDR66C(stIdString, sRelayConvert[0], sRelayConvert[1], sRelayConvert[2], sRelayConvert[3], sRelayConvert[4], sRelayConvert[5], Form1.GetTimeStamp());
                if (i >= byX66cNumber)
                {
                    stPollString += JsonConvert.SerializeObject(OneNodeJsonPackage) + "]";
                    return stPollString;
                }
                else
                    stPollString += JsonConvert.SerializeObject(OneNodeJsonPackage) + ",";
            }
            return stPollString;
        }
        public static async void vCheckAlarm_And_Send(IMqttClient mqttClient)
        {
            bool bOccurErrorChange = false;
            for (byte i = 0; i < byX14pNumber; i++)
            {
                ushort[] usChannelErrorlist     = { };
                ushort[] usChannelErrorCodeList = { };
                byte k = 0;
                for (byte j = 0; j < byX14pReadDataNumber; j++)
                {
                    if (cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] != cx14P.sX14PAlarmStruct[i].usBeforeAlarmCode[j])
                    {
                        bOccurErrorChange = true;
                        usChannelErrorlist[k++]    = j;
                        usChannelErrorCodeList[k++] = (ushort)cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j];
                    }
                    cx14P.sX14PAlarmStruct[i].usBeforeAlarmCode[j] = cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j];
                }
                cModualAlarm.vSetAlarmList(i, usChannelErrorlist, usChannelErrorCodeList,true);
            }

            for (byte i = 0; i < byX18xNumber; i++)
            {
                ushort[] usChannelErrorlist = { };
                ushort[] usChannelErrorCodeList = { };
                byte k = 0;
                for (byte j = 0; j < byX18xReadTypeNumber; j++)
                {
                    if (cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] != cx18x.sX18xAlarmstruct[i].usBeforeAlarmCode[j])
                    {
                        bOccurErrorChange = true;
                        usChannelErrorlist[k++] = j;
                        usChannelErrorCodeList[k++] = (ushort)cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j];
                    }
                    cx18x.sX18xAlarmstruct[i].usBeforeAlarmCode[j] = cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j];
                }
                cModualAlarm.vSetAlarmList(i, usChannelErrorlist, usChannelErrorCodeList,true);
            }

            for (byte i = 0; i < byX78cNumber; i++)
            {
                ushort[] usChannelErrorlist = { };
                ushort[] usChannelErrorCodeList = { };
                byte k = 0;
                for (byte j = 0; j < byX78cOutputRegNumber + byX78cInputRegNumber; j++)
                {
                    if (cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j] != cx78c.sX78cAlarmStruct[i].usBeforeAlarmCode[j])
                    {
                        bOccurErrorChange = true;
                        usChannelErrorlist[k++] = j;
                        usChannelErrorCodeList[k++] = (ushort)cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j];
                    }
                    cx78c.sX78cAlarmStruct[i].usBeforeAlarmCode[j] = cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j];
                }
                cModualAlarm.vSetAlarmList(i, usChannelErrorlist, usChannelErrorCodeList, true);
            }

            for (byte i = 0; i < byX66cNumber; i++)
            {
                ushort[] usChannelErrorlist = { };
                ushort[] usChannelErrorCodeList = { };
                byte k = 0;
                for (byte j = 0; j < byX66cRelayRegNumber; j++)
                {
                    if (cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j] != cx66c.sX66cAlarmStruct[i].usBeforeAlarmCode[j])
                    {
                        bOccurErrorChange = true;
                        usChannelErrorlist[k++] = j;
                        usChannelErrorCodeList[k++] = (ushort)cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j];
                    }
                    cx66c.sX66cAlarmStruct[i].usBeforeAlarmCode[j] = cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j];
                }
                cModualAlarm.vSetAlarmList(i, usChannelErrorlist, usChannelErrorCodeList,i == byX66cNumber ? true:false);
            }
            if (bOccurErrorChange == true)
            {
                await cModualAlarm.vPublishAlarmPackageJson(mqttClient);
            }
        }
    }
}
